scala.reflect.quasiquotes

# Quasiquotes

###
Related Doc: package quasiquotes

#### abstract class Quasiquotes extends Parsers with Holes with Placeholders with Reifiers

Source
  Quasiquotes.scala

Linear Supertypes
Reifiers, Placeholders, Holes, Parsers, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Quasiquotes
2. Reifiers
3. Placeholders
4. Holes
5. Parsers
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Quasiquotes()

### Type Members

1. #### class ApplyHole extends Quasiquotes.Hole

   Definition Classes
     Holes

2. #### class ApplyReifier extends Quasiquotes.Reifier

   Definition Classes
     Reifiers

3. #### abstract class Hole extends AnyRef

   Hole encapsulates information about unquotees in quasiquotes.

   Hole encapsulates information about unquotees in quasiquotes. It packs together a rank, pre-reified tree representation (possibly preprocessed) and position.

   Definition Classes
     Holes

4. #### trait HolePlaceholder extends AnyRef

   Definition Classes
     Placeholders

5. #### abstract class Parser extends tools.nsc.ast.parser.Parsers

   Definition Classes
     Parsers

6. #### abstract class Reifier extends reify.Reifier

   Definition Classes
     Reifiers

7. #### class UnapplyHole extends Quasiquotes.Hole

   Definition Classes
     Holes

8. #### class UnapplyReifier extends Quasiquotes.Reifier

   Definition Classes
     Reifiers

### Abstract Value Members

1. #### abstract val c: Context

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Quasiquotes to any2stringadd[Quasiquotes] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Quasiquotes, B)

   Implicit information
     This member is added by an implicit conversion from Quasiquotes to ArrowAssoc[Quasiquotes] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object AnnotPlaceholder extends Quasiquotes.HolePlaceholder

   Definition Classes
     Placeholders

7. #### object CaseParser extends Quasiquotes.Parser

   Definition Classes
     Parsers

8. #### object CasePlaceholder

   Definition Classes
     Placeholders

9. #### object EarlyDefPlaceholder

   Definition Classes
     Placeholders

10. #### object ForEnumPlaceholder

    Definition Classes
      Placeholders

11. #### object ForEnumeratorParser extends Quasiquotes.Parser

    Definition Classes
      Parsers

12. #### object FreshName extends tools.nsc.Global.FreshNameExtractor

    Definition Classes
      Parsers

13. #### object FunctionTypePlaceholder

    Definition Classes
      Placeholders

14. #### object Hole

    Definition Classes
      Holes

15. #### object ModsPlaceholder extends Quasiquotes.HolePlaceholder

    Definition Classes
      Placeholders

16. #### object PackageStatPlaceholder

    Definition Classes
      Placeholders

17. #### object ParamPlaceholder extends Quasiquotes.HolePlaceholder

    Definition Classes
      Placeholders

18. #### object PatternParser extends Quasiquotes.Parser

    Definition Classes
      Parsers

19. #### object Placeholder extends Quasiquotes.HolePlaceholder

    Definition Classes
      Placeholders

20. #### object Q

    Wrapper around tree parsed in q"..." quote.

    Wrapper around tree parsed in q"..." quote. Needed to support ..$ splicing on top-level.

    Definition Classes
      Parsers

21. #### object RefineStatPlaceholder

    Definition Classes
      Placeholders

22. #### object SymbolPlaceholder

    Definition Classes
      Placeholders

23. #### object TermParser extends Quasiquotes.Parser

    Definition Classes
      Parsers

24. #### object TuplePlaceholder

    Definition Classes
      Placeholders

25. #### object TupleTypePlaceholder

    Definition Classes
      Placeholders

26. #### object TypeParser extends Quasiquotes.Parser

    Definition Classes
      Parsers

27. #### lazy val args: List[tools.nsc.Global.Tree]

28. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

29. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

30. #### lazy val code: String

    Definition Classes
      Placeholders

31. #### def debug(msg: ⇒ String): Unit

32. #### def ensuring(cond: (Quasiquotes) ⇒ Boolean, msg: ⇒ Any): Quasiquotes

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to Ensuring[Quasiquotes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### def ensuring(cond: (Quasiquotes) ⇒ Boolean): Quasiquotes

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to Ensuring[Quasiquotes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: Boolean, msg: ⇒ Any): Quasiquotes

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to Ensuring[Quasiquotes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### def ensuring(cond: Boolean): Quasiquotes

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to Ensuring[Quasiquotes] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

36. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

38. #### def expandQuasiquote: tools.nsc.Global.Tree

39. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

40. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to StringFormat[Quasiquotes] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

41. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

42. #### val global: macros.contexts.Context.universe.type

43. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

44. #### object holeMap

    Definition Classes
      Placeholders

45. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

46. #### lazy val method: tools.nsc.Global.Name

47. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

48. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

49. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

50. #### lazy val parse: (String) ⇒ tools.nsc.Global.Tree

51. #### lazy val parts: collection.immutable.List[(String, tools.nsc.Global.Position)]

52. #### lazy val posMap: LinkedHashMap[Position, (Int, Int)]

    Definition Classes
      Placeholders

53. #### lazy val reify: (tools.nsc.Global.Tree) ⇒ tools.nsc.Global.Tree

54. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

55. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

56. #### lazy val u: tools.nsc.Global.Tree

57. #### lazy val universe: tools.nsc.Global.Tree

58. #### lazy val universeTypes: internal.Definitions.definitions.UniverseDependentTypes

59. #### object unlifters

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values.

    Full support for unliftable implies that it's possible to interleave deconstruction with higher rank and unlifting of the values. In particular extraction of List[Tree] as List[T: Unliftable] requires helper extractors that would do the job: UnliftListElementwise[T]. Similarly List[List[Tree]] needs UnliftListOfListsElementwise[T].

    See also "unlift list" tests in UnapplyProps.scala

    Definition Classes
      Holes

60. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

61. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

62. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

63. #### def →[B](y: B): (Quasiquotes, B)

    Implicit information
      This member is added by an implicit conversion from Quasiquotes to ArrowAssoc[Quasiquotes] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Reifiers

### Inherited from Placeholders

### Inherited from Holes

### Inherited from Parsers

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Quasiquotes to any2stringadd[Quasiquotes]

### Inherited by implicit conversion StringFormat from Quasiquotes to StringFormat[Quasiquotes]

### Inherited by implicit conversion Ensuring from Quasiquotes to Ensuring[Quasiquotes]

### Inherited by implicit conversion ArrowAssoc from Quasiquotes to ArrowAssoc[Quasiquotes]

### Ungrouped